#include amxmodx
#include hamsandwich
#include nvault

#define PL_NAME							"JBE Ranks"
#define PL_VERSION						"0.2.4"
#define PL_AUTHOR						"OverGame"

#define PL_FILE_LEVELS					"/addons/amxmodx/configs/jbe_ranks/levels.ini"

native jbe_get_user_team(client);

enum PLAYER_DATA
{
	PLAYER_LEVEL,
	PLAYER_EXP,
	PLAYER_TARGET,
	PLAYER_STEAM[35]
};
enum CVARS_DATA
{
	CVAR_GIVE_ROUND,
	CVAR_GIVE_KILLED,
	CVAR_GIVE_BONUS_ADM,
	CVAR_MAX_PLAYERS,
	CVAR_GIVE_BONUS_FLAG,
	CVAR_VAULT
};
enum LEVELS_DATA
{
	LEVEL_NAME[32],
	LEVEL_EXP
};
new g_PlayerData[33][PLAYER_DATA], g_CvarsData[CVARS_DATA];
new Array:g_Levels, g_LevelsData[LEVELS_DATA];

public plugin_init()
{
	register_plugin(PL_NAME, PL_VERSION, PL_AUTHOR);
	g_Levels = ArrayCreate(LEVELS_DATA);
	
	register_logevent("LogEvent_Round_End", 2, "1=Round_End");
	register_dictionary("jbr_core.txt");
	
	RegisterHam(Ham_Spawn, "player", "Ham_PlayerSpawn_Post", true);
	RegisterHam(Ham_Killed, "player", "Ham_PlayerKilled_Post", true);
	
	g_CvarsData[CVAR_MAX_PLAYERS] = get_maxplayers();
	g_CvarsData[CVAR_GIVE_ROUND] = register_cvar("jbr_give_round", 				"");
	g_CvarsData[CVAR_GIVE_KILLED] = register_cvar("jbr_give_killed", 			"");
	g_CvarsData[CVAR_GIVE_BONUS_ADM] = register_cvar("jbr_give_bonus_adm", 		"");
	g_CvarsData[CVAR_GIVE_BONUS_FLAG] = register_cvar("jbr_give_bonus_flag", 	"");
}

public plugin_cfg()
{
	new szCfgDir[96];
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	server_cmd("exec %s/jbe_ranks/configs.cfg", szCfgDir);
	
	g_CvarsData[CVAR_VAULT] = nvault_open("jbr_core");
	if(g_CvarsData[CVAR_VAULT] == INVALID_HANDLE) set_fail_state("Error opening nVault!");
	
	Func_LoadLevels();
}

public Ham_PlayerKilled_Post(victim, killer)
{
	if(is_user_connected(victim) && is_user_connected(killer) && victim != killer && killer > 0)
	{
		new sVictim[33]; get_user_name(victim, sVictim, charsmax(sVictim));
		new count = get_pcvar_num(g_CvarsData[CVAR_GIVE_KILLED]);
		jbr_give_user_exp(killer, count, "%L", LANG_SERVER, "JBR_KILLED", count, sVictim);
	}
}

public Ham_PlayerSpawn_Post(client) if(is_user_connected(client) && jbr_get_user_flags(client)) {
	new count = get_pcvar_num(g_CvarsData[CVAR_GIVE_BONUS_ADM]);
	jbr_give_user_exp(client, count, "%L", LANG_SERVER, "JBR_SPAWN_ADMIN", count);
}

public LogEvent_Round_End()
{
	for(new client = 1; client <= g_CvarsData[CVAR_MAX_PLAYERS]; client++)
	{
		if(!is_user_connected(client) || !is_user_alive(client)) continue;
		new count = get_pcvar_num(g_CvarsData[CVAR_GIVE_ROUND]);
		jbr_give_user_exp(client, count, "%L", LANG_SERVER, "JBR_GIVE_ROUND", count);
	}
}

public client_authorized(client)
	get_user_authid(client, g_PlayerData[client][PLAYER_STEAM], 34);

public client_putinserver(client)
	g_PlayerData[client][PLAYER_LEVEL] = 0, g_PlayerData[client][PLAYER_EXP] = 0, jbr_base_vault(client, 0);

public client_disconnect(client)
	jbr_base_vault(client, 1);
	
public Func_CheckLevel(client)
{
	if(g_PlayerData[client][PLAYER_LEVEL]+1 >= ArraySize(g_Levels)) return false;
	if(g_PlayerData[client][PLAYER_LEVEL]<0) g_PlayerData[client][PLAYER_LEVEL] = 0;
	if(g_PlayerData[client][PLAYER_EXP]<0) g_PlayerData[client][PLAYER_EXP] = 0;
	ArrayGetArray(g_Levels, g_PlayerData[client][PLAYER_LEVEL]+1,g_LevelsData);
	if(g_PlayerData[client][PLAYER_EXP] >= g_LevelsData[LEVEL_EXP])
		g_PlayerData[client][PLAYER_LEVEL]++;
		
	return true;
}

public Func_LoadLevels()
{
	new szBuf[256], szExp[5], file = fopen(PL_FILE_LEVELS, "r");
	while(!feof(file))
	{
		fgets(file, szBuf, 255);
		trim(szBuf);
		
		if(szBuf[0] == '"')
		{
			parse(szBuf, g_LevelsData[LEVEL_NAME], 31, szExp, 4);
			g_LevelsData[LEVEL_EXP] = str_to_num(szExp);
			ArrayPushArray(g_Levels, g_LevelsData);
		} else continue;
	}
	fclose(file);
}

public plugin_natives()
{
	register_native("jbr_get_user_rankname", "native_get_user_rankname", false );
	register_native("jbr_get_user_level", "native_get_user_level", true);
	register_native("jbr_get_user_exp", "native_get_user_exp", true);
	register_native("jbr_is_user_max", "native_is_user_max", true);
	register_native("jbr_get_max_level", "native_get_max_level", true);
}

public native_is_user_max(client)
{
	static status[33]; status[client] = false;
	if(g_PlayerData[client][PLAYER_LEVEL]+1 >= ArraySize(g_Levels))
		status[client] = true;
	
	return status[client];
}
public native_get_max_level() return ArraySize(g_Levels);
public native_get_user_exp(client) return g_PlayerData[client][PLAYER_EXP];
public native_get_user_level(client) return g_PlayerData[client][PLAYER_LEVEL];
native jbr_get_user_rankname(sBuf[], len, client);
public native_get_user_rankname()
{
	new len = get_param(2);
	new client = get_param(3);
	ArrayGetArray(g_Levels, g_PlayerData[client][PLAYER_LEVEL],g_LevelsData);
	set_string(1, g_LevelsData[LEVEL_NAME], len);
	return 1;
}

stock jbr_base_vault(client, type = 0)
{
	static status[33]; status[client] = true;
	switch(type)
	{
		case 0:
		{
			new s_Get_Buffer[40];
			formatex(s_Get_Buffer, charsmax(s_Get_Buffer), "%sRANK", g_PlayerData[client][PLAYER_STEAM]);
			new s_Level = nvault_get(g_CvarsData[CVAR_VAULT], s_Get_Buffer);
			if(s_Level >= 0) g_PlayerData[client][PLAYER_LEVEL] = s_Level;
			else status[client] = false;
			
			formatex(s_Get_Buffer, charsmax(s_Get_Buffer), "%sEXP", g_PlayerData[client][PLAYER_STEAM]);
			new s_Exp = nvault_get(g_CvarsData[CVAR_VAULT], s_Get_Buffer);
			if(s_Exp >= 0) g_PlayerData[client][PLAYER_EXP] = s_Exp;
			else status[client] = false;
		}
		case 1:
		{
			new s_Get_Buffer[40], s_Level[64], s_Exp[64];
			format(s_Get_Buffer, charsmax(s_Get_Buffer), "%sRANK", g_PlayerData[client][PLAYER_STEAM]);
			format(s_Level, charsmax ( s_Level ), "%d", g_PlayerData[client][PLAYER_LEVEL]);
			nvault_set(g_CvarsData[CVAR_VAULT], s_Get_Buffer, s_Level);
			
			format(s_Get_Buffer, charsmax(s_Get_Buffer) , "%sEXP", g_PlayerData[client][PLAYER_STEAM]);
			format(s_Exp, charsmax(s_Exp), "%d", g_PlayerData[client][PLAYER_EXP]);
			nvault_set(g_CvarsData[CVAR_VAULT], s_Get_Buffer, s_Exp);
		}
	}
	return status[client];
}

stock jbr_get_user_flags(client)
{
	new sFlags[32], sFlag[ 5 ], flags = get_user_flags(client), status[33]; status[client] = false;
	get_pcvar_string(g_CvarsData[CVAR_GIVE_BONUS_FLAG], sFlag, charsmax(sFlag));
	get_flags(flags, sFlags, charsmax(sFlags));
	if(contain(sFlags, sFlag) != -1) status[client] = true;
	return status[client];
}

stock jbr_give_user_exp(client, count, const input[], any:...)
{
	static msg[188];
	vformat(msg, 187, input, 4);
	if(jbe_get_user_team(client) == 2 || count <= 0) return false;
	g_PlayerData[client][PLAYER_EXP] += count;
	send_chat(client, "%L %s", LANG_SERVER, "JBR_PREFIX", msg);
	return Func_CheckLevel(client);
}

stock send_chat(client, const input[], any:...)
{
	new count = 1, players[32];
	static msg[188];
	vformat(msg, 187, input, 3);
	
	replace_all(msg, 187, "!g", "^4");
	replace_all(msg, 187, "!y", "^1");
	replace_all(msg, 187, "!t", "^3");
	
	if(client) players[0] = client; else get_players(players, count, "ch");
	{
		for(new i = 0; i < count; i++)
		{
			if(is_user_connected(players[i]))
			{
				message_begin(MSG_ONE_UNRELIABLE, get_user_msgid("SayText"), _, players[i]);
				write_byte(players[i]);
				write_string(msg);
				message_end();
			}
		}
	}
}